/*$Id: c_modify.cc,v 13.31 1999/04/16 07:48:59 al Exp $ -*- C++ -*-
 */
#include "u_cardst.h"
#include "c_comand.h"
#include "e_card.h"
#include "ap.h"
enum WHATTODO {FAULT, MODIFY};
/*--------------------------------------------------------------------------*/
//	void	CMD::modify(CS&);
//	void	CMD::fault(CS&);
static	void	modify_fault(CS&,WHATTODO);
static	double	sweep_fix(CS&,const CARD*);
static	void	faultbranch(CARD*,double);
//	void	CMD::restore(CS&);
//	void	CMD::unfault(CS&);
/*--------------------------------------------------------------------------*/
extern const char e_int[];
extern CONST bool crtplot;
extern CONST int swp_type[];
extern CONST int swp_count[], swp_steps[];
extern CONST int swp_nest;
static std::stack<CARDSTASH, std::list<CARDSTASH> > faultstack;
/*--------------------------------------------------------------------------*/
void CMD::modify(CS& cmd)
{
  modify_fault(cmd,MODIFY);
}
/*--------------------------------------------------------------------------*/
void CMD::fault(CS& cmd)
{
  modify_fault(cmd,FAULT);
}
/*--------------------------------------------------------------------------*/
static void modify_fault(CS& cmd, WHATTODO command)
{
  SIM::uninit();
  while (cmd.is_alpha()){    
    int mark = cmd.cursor();
    int cmax = cmd.cursor();
    CARD_LIST::fat_iterator ci(&CARD_LIST::card_list);
    for (;;){
      cmd.reset(mark);
      ci = findbranch(cmd, ci);
      cmax = max(cmax, cmd.cursor());
      if (ci.isend()){
	break;
      }
      CARD* brh = *ci;
      switch (command) {
      case MODIFY:
	brh->setvalue(cmd.ctof(), 0);
	break;
      case FAULT:
	faultbranch(brh, sweep_fix(cmd,brh));
	break;
      }
      ++ci;
    }
    cmd.reset(cmax);
    if (mark == cmax){
      untested();
      cmd.check(bWARNING);
      cmd.skiparg();
    }
  }
}   
/*--------------------------------------------------------------------------*/
/* sweep_fix: fix the value for sweep command.
 * (find value by interpolation)
 * if not sweeping, return "start" (the first arg).
 */
static double sweep_fix(CS& cmd, const CARD *brh)
{
  double start = cmd.ctof();
  double value = start;
  if (swp_steps[swp_nest] != 0   &&   cmd.is_float()){
    undertested();
    double last = cmd.ctof();
    double offset = static_cast<double>(swp_count[swp_nest]) 
      / static_cast<double>(swp_steps[swp_nest]);
    {if (swp_type[swp_nest]=='L'){
      {if (start == 0.){
	error(bERROR, "log sweep can't pass zero\n");
	value = 0;
      }else{
	value = start * pow( (last/start), offset );
      }}
    }else{
      value = start + (last-start) * offset;
    }}
    if (!crtplot){
      IO::mstdout.setfloatwidth(7)
	<< swp_count[swp_nest]+1 << "> sweep " << brh->printlabel()
	<< " =" << value << '\n';
    }
  }
  return value;
}
/*--------------------------------------------------------------------------*/
/* faultbranch: "fault" a single branch. (temporarily change a value)
 * save the existing info in "faultlist", then patch
 */
static void faultbranch(CARD* brh, double value)
{
  if (!brh->isdevice()){
    untested();
    error(bWARNING, "%s: not a device, can't fault:\n", brh->printlabel());
  }else if (brh->subckt().exists()){
    untested();
    error(bWARNING, "%s has subckt, can't fault:\n%s\n", brh->printlabel());
  }else{
    faultstack.push(CARDSTASH(brh));
    brh->setvalue(value, 0);
  }
}
/*--------------------------------------------------------------------------*/
void CMD::restore(CS& cmd)
{
  unfault(cmd);
  unmark(cmd);
}
/*--------------------------------------------------------------------------*/
/* CMD::unfault: (command) remove faults and restore pre-fault values
 */
void CMD::unfault(CS&)
{
  while (!faultstack.empty()){
    faultstack.top().restore();
    faultstack.pop();
  }
  SIM::uninit();
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
