/*$Id: e_bm.h,v 13.43 1999/06/01 15:25:51 al Exp $ -*- C++ -*-
 * HSPICE style behavioral modeling
 */
#ifndef E_BM_H
#define E_BM_H
#include "l_inttbl.h"
#include "e_elemnt.h"
/*--------------------------------------------------------------------------*/
class EVAL_BM_BASE: public COMPONENT_COMMON {
protected:
  double scale;
  double tc1;
  double tc2;
  double ic;
  bool   hasoptions;
  
protected:
  explicit EVAL_BM_BASE(int c=0)
    :COMPONENT_COMMON(c),scale(1.),tc1(0),tc2(0),ic(0),hasoptions(false){}
  explicit EVAL_BM_BASE(const EVAL_BM_BASE& p)
    :COMPONENT_COMMON(p), scale(p.scale), tc1(p.tc1), tc2(p.tc2),
     ic(p.ic), hasoptions(p.hasoptions) {untested();}
};
/*--------------------------------------------------------------------------*/
class EVAL_BM_PWL : public EVAL_BM_BASE {
private:
  double delta;
  int    smooth;
  std::vector<PAIR<double,double> > table;
private:
  EVAL_BM_PWL&	setdefault();
public:
  explicit      EVAL_BM_PWL(int c=0)	:EVAL_BM_BASE(c) {setdefault();}
  explicit	EVAL_BM_PWL(const EVAL_BM_PWL& p);
		~EVAL_BM_PWL()		{}

  const char*	name()const		{return "PWL";}

  void		parse(CS&);
  void		print(OMSTREAM)const;

  void		tr_eval(COMPONENT*d)const;
  bool		has_tr_eval()const	{return true;}
};
/*--------------------------------------------------------------------------*/
class EVAL_BM_POLY : public EVAL_BM_BASE {
private:
  double max;
  double min;
  bool   abs;
  std::vector<double> c;
private:
  EVAL_BM_POLY&	setdefault();
public:
  explicit      EVAL_BM_POLY(int c=0)	:EVAL_BM_BASE(c) {setdefault();}
  explicit	EVAL_BM_POLY(const EVAL_BM_POLY& p);
		~EVAL_BM_POLY()		{}

  const char*	name()const		{return "POLY";}

  void		parse(CS&);
  void		print(OMSTREAM)const;

  void		tr_eval(COMPONENT*d)const;
  bool		has_tr_eval()const	{return true;}
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
