/*$Id: e_storag.h,v 13.43 1999/06/01 15:25:51 al Exp $ -*- C++ -*-
 * "base" class for energy storage elements (L & C)
 */
#ifndef E_STORAGE_H
#define E_STORAGE_H
#include "e_elemnt.h"
/*--------------------------------------------------------------------------*/
enum METHOD {mTRAPGEAR, mEULER, mTRAP, mGEAR, mTRAPEULER};
/*--------------------------------------------------------------------------*/
class STORAGE : public ELEMENT {
protected:
  explicit STORAGE();
  explicit STORAGE(const STORAGE& p);
private: // overloaded virtual
  CARD&	   expand();
  double   tr_involts()const	{return tr_outvolts();}
  COMPLEX  ac_involts()const	{return ac_outvolts();}
  bool	   is1port()const	{return true;}
protected:
  bool	   advance();
  double   review(double, double);
protected:
  METHOD   method_a;	/* actual integration method (auto)	*/
  double   timef;	/* future event time			*/
  double   time0;	/* time now (y[012], m[01])		*/
  double   time1;	/* one tick ago	 (mt1, yt1)		*/
  double   time2;	/* two tick ago	 (mt2, yt2)		*/
  double   time3;	/* two tick ago	 (mt3. yt3)		*/
//fpoly1_t y0;		/* iteration parameters, new		*/
  fpoly1_t yt1;		/* iteration parameters, 1 time ago	*/
  fpoly1_t yt2;		/* iteration parameters, 2 times ago	*/
  fpoly1_t yt3;		/* iteration parameters, 3 times ago	*/
//fpoly1_t y1;		/* iteration parameters, 1 iter ago	*/
//fpoly1_t y2;		/* iteration parameters, 2 iter ago	*/
//cpoly1_t m0;		/* matrix parameters, new		*/
//cpoly1_t m1;		/* matrix parameters, 1 fill ago	*/
  cpoly1_t mt1;		/* matrix parameters, 1 time ago	*/

//COMPLEX  ev;		/* ac effective value (usually real)	*/
//COMPLEX  acg;		/* ac admittance matrix values		*/   
//double   acbias;	/* dc bias for ac use			*/
private:
  static METHOD method_select[meNUM_METHODS][meNUM_METHODS];
};
// commented out declarations mean inherited
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
